/* c-tree Plus Application Header File */

#ifndef CTREEPH
#define CTREEPH

#include "ctstdr.h"
		/* All programs that use c-tree must have
		 * this include statement. it automatically
		 * includes several necessary
		 * header files (including the compiler's
		 * "stdio.h")
		 */
#include "ctoptn.h"
		/* This is your configuration header. There are a number of 
		 * features that are enabled or disabled by settings in this 
		 * header. It should always be included.
		 */
#include "ctaerr.h"
		/* This contains declarations for a number of global variables,
		 * including the error code variables, that you will need 
		 * access to.
		 */				 
#include "ctdecl.h"
		/* This include contains the c-tree Plus function prototypes.
		 * It is important that you include this.
		 */
#include "cterrc.h"
		/* By including this we can use the c-tree
		 * error code mnemonics in our error handling
		 */

		/* We always prefer to use symbolic names
		 * whenever we can, for constants. This
		 * allows us to easily change the constant
		 * throughout the program by just changing
		 * the definition in one place. Here we are
		 * defining the file numbers that we will
		 * use for both the data and the index file.*/

#ifdef ctNOGLOBALS
#define MYctWNGV 	((pCTGVAR)(GETCTREE((pTEXT)WCHCTREE())))
#endif

#ifdef ctNOGLOBALS
#ifdef	uerr_cod
#undef	uerr_cod
#define uerr_cod	((COUNT)(!MYctWNGV ? (COUNT)-1 : MYctWNGV->suerr_cod))
#endif
#endif

#ifdef ctNOGLOBALS
#ifdef	sysiocod
#undef	sysiocod
#define sysiocod	((COUNT)(!MYctWNGV ? (COUNT)-1 : MYctWNGV->ssysiocod))
#endif
#endif

#ifdef ctNOGLOBALS
#ifdef	isam_err
#undef	isam_err
#define isam_err	((COUNT)(!MYctWNGV ? (COUNT)-1 : MYctWNGV->sisam_err))
#endif
#endif

#ifdef ctNOGLOBALS
#ifdef	isam_fil
#undef	isam_fil
#define isam_fil	((COUNT)(!MYctWNGV ? (COUNT)-1 : MYctWNGV->sisam_fil))
#endif
#endif

#endif /* CTREEPH */
/* end of ctree.h */
